<?php

namespace EventPortal\Domain\Delegate\Handlers;

use Closure;
use EventPortal\Domain\Form\Payload;
use EventPortal\Domain\Util\Notification\Facades\Notification;

class ContactEvent
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        /** @var \EventPortal\Domain\Event\Models\Event $event */
        $event = $payload->getModel();

        Notification::make('event.contact')
            ->event($event)
            ->form($payload->getInput())
            ->to($event)
            ->send();

        return $next($payload);
    }
}
