<?php

namespace EventPortal\Domain\Form;

use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Event\Form\Models\Form as FormModel;

class DisplayForm
{
    /** @var \EventPortal\Domain\Delegate\Models\Delegate */
    private $delegate;

    /** @var \EventPortal\Domain\Event\Form\Models\Form */
    private $formModel;

    public static function make(): self
    {
        return new self();
    }

    public function forDelegate(Delegate $delegate): self
    {
        $this->delegate = $delegate;

        return $this;
    }

    public function forForm(FormModel $form): self
    {
        $this->formModel = $form;

        return $this;
    }

    public function render(): array
    {
        $this->formModel->loadMissing([
            'steps.sections.questions',
        ]);

        return $this
            ->formModel
            ->asComponent($this->delegate, true)
            ->render();
    }
}
