<?php

namespace EventPortal\Providers;

use EventPortal\Domain\Email\Models\EventEmail;
use EventPortal\Domain\Email\Observers\EventEmailObserver;
use EventPortal\Domain\Util\Notification\Models\EventNotification;
use Illuminate\Queue\Events\JobProcessed;
use Illuminate\Support\Facades\Queue;
use Illuminate\Support\ServiceProvider;

class EventListenerProvider extends ServiceProvider
{
    public function boot(): void
    {
        EventEmail::observe(EventEmailObserver::class);

        Queue::after(function (JobProcessed $event): void {
            $notification = unserialize($event->job->payload()['data']['command'])->notification;

            if ($notification->key !== 'event.invite') {
                return;
            }

            $eventNotification = EventNotification::find($notification->data->getDatabaseId());
            $eventNotification->apply('sent');
            $eventNotification->save();
        });
    }
}
