<?php

namespace EventPortal\Tests\Unit\Event\Actions;

use EventPortal\Domain\Event\Actions\DeleteEvent;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Event\Models\EventDelegate;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class DeleteEventTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function event_is_deleted()
    {
        $event = factory(Event::class)->create();

        (new DeleteEvent)->execute($event);

        $event = $event->fresh();

        $this->assertNull($event);
    }

    /** @test **/
    public function associated_delegates_are_deleted()
    {
        $eventDelegate = factory(EventDelegate::class)->create();

        $event = $eventDelegate->event;

        (new DeleteEvent)->execute($event);

        $this->assertEmpty($event->delegates);
    }
}
